#!/usr/bin/env python
from pytestutils import *
import sphere

print("### Restart tests ###")

# Generate data in python
orig = sphere.sim(np=10000, nw=1, sid="test-initgrid")
orig.generateRadii(histogram=False)
orig.defaultParams()
orig.g[2] = 0.0
orig.initRandomGridPos(gridnum = [100, 100, 100])
orig.initTemporal(current=0.0, total=0.0)
orig.time_total[0] = 1e-7
orig.time_file_dt[0] = 1e-8
orig.writebin(verbose = False)
orig.run(dry=True)
orig.run()

restart = sphere.sim()
restart.readbin("../output/" + orig.sid + ".output{:0=5}.bin".format(orig.status()))
restart.time_total[0] += 1e-7
restart.time_file_dt[0] = 1e-8
restart.run(dry=True)
restart.run()
restart.readlast()
restart.time_current = orig.time_current
restart.time_step_count = orig.time_step_count
restart.time_total = orig.time_total

compare(orig, restart, "Restart test:  ")

# Remove temporary files
cleanup(orig)
cleanup(restart)
